package com.hfkj.service.goods.impl;

import com.hfkj.dao.GoodsTypeMapper;
import com.hfkj.entity.GoodsType;
import com.hfkj.entity.GoodsTypeExample;
import com.hfkj.service.goods.GoodsTypeService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("goodsTypeService")
public class GoodsTypeServiceImpl implements GoodsTypeService {

    @Resource
    private GoodsTypeMapper goodsTypeMapper;

    @Override
    public void create(GoodsType goodsType) {
        goodsTypeMapper.insert(goodsType);
    }

    @Override
    public void update(GoodsType goodsType) {
        goodsTypeMapper.updateByPrimaryKey(goodsType);
    }

    @Override
    public void delete(Long id , Boolean fullDelete) {
        if (fullDelete) {
            goodsTypeMapper.deleteByPrimaryKey(id);
        } else {
            GoodsType goodsType = queryDetail(id);
            goodsType.setStatus(0);
            goodsType.setUpdateTime(new Date());
            update(goodsType);
        }
    }

    @Override
    public GoodsType queryDetail(Long id) {
        return goodsTypeMapper.selectByPrimaryKey(id);
    }

    @Override
    public GoodsType queryDetailByMap(Map<String, Object> map) {

        GoodsTypeExample example = new GoodsTypeExample();
        GoodsTypeExample.Criteria criteria = example.createCriteria().andStatusNotEqualTo(0);

        if (MapUtils.getLong(map, "parentId") != null) {
            criteria.andParentIdEqualTo(MapUtils.getLong(map, "parentId"));
        }
        if (MapUtils.getString(map, "title") != null) {
            criteria.andTitleEqualTo(MapUtils.getString(map, "title"));
        }
        if (MapUtils.getInteger(map, "businessType") != null) {
            criteria.andBusinessTypeEqualTo(MapUtils.getInteger(map, "businessType"));
        }

        List<GoodsType> list = goodsTypeMapper.selectByExample(example);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public List<GoodsType> getList(Map<String, Object> map) {

        GoodsTypeExample example = new GoodsTypeExample();
        GoodsTypeExample.Criteria criteria = example.createCriteria().andStatusNotEqualTo(0);

        if (MapUtils.getLong(map, "parentId") != null) {
            criteria.andParentIdEqualTo(MapUtils.getLong(map, "parentId"));
        }
        if (MapUtils.getString(map, "title") != null) {
            criteria.andTitleEqualTo(MapUtils.getString(map, "title"));
        }
        if (MapUtils.getInteger(map, "businessType") != null) {
            criteria.andBusinessTypeEqualTo(MapUtils.getInteger(map, "businessType"));
        }

        return goodsTypeMapper.selectByExample(example);
    }
}
